#include "onewaylist.h"
#include <cstdlib>

Node::Node(): data(0),next(nullptr) {}
Node::Node(int value): data(value),next(nullptr) {}
OnewayList::OnewayList(): head(nullptr) {}
OnewayList::OnewayList(int value): head(
        #ifdef UNIQUE
        std::make_unique<Node>(value)
        #else
new Node(value)
#endif
        ) {}
void OnewayList::append(int value) {
    if (head == (NULL)) {
        head=
#ifdef UNIQUE
            std::make_unique<Node>(value);
#else
            new Node(value);
#endif
        return;
    }
    Node* temp=head
#ifdef UNIQUE
        .get()
#endif
        ;
    while (temp->next != nullptr) {
        temp=temp->next
#ifdef UNIQUE
                   .get()
#endif
            ;
    }
    temp->next=
#ifdef UNIQUE
        std::make_unique<Node>
#else
        new Node
#endif
        (value);
}
bool OnewayList::remove(int pos) {
    if (!head)return 0;
    
    if (pos == 0) {
        Node* temp=head
#ifdef UNIQUE
                         .get()
#endif
            ;if (head->next)head=
#ifdef UNIQUE
                std::move(head->next)
#else
                head->next
#endif
                ;else head = nullptr;//Ми нічого не втрачаємо, адже адреса голови досі в head.
#ifndef UNIQUE                       //також видаляємо те, що було в head. Без цього не можна,
        delete temp;                 //адже в Node є статичні поля, в яких щось має бути -
#endif                               //Якщо лишити там, наприклад, 0 - це теж буде ключем.
        return 1;                    //до того ж, це править момент з head == nullptr вище
    }                                //і ми точно зннаємо, що значення там відсутнє.
    Node* prev;
    Node* current=head
#ifdef UNIQUE
    .get()
#endif
            ;int index = 0;
for (int i=0;i<pos;i++){if(current==nullptr) return 0;prev=current
        ;current=current->next
#ifdef UNIQUE
        .get()
#endif
        ;}
    
    if (current->next)prev->next=
#ifdef UNIQUE
            std::move(current->next);
#else
            current->next;
    delete current;
#endif
    return 1;
}

int OnewayList::get(int pos)const
{
    Node* temp = head
#ifdef UNIQUE
                     .get()
#endif
        ;
    int index = 0;
    while (temp != nullptr && index != pos) {
        temp=temp->next
#ifdef UNIQUE
                   .get()
#endif
            ;index++;
    }
    
    if (temp != nullptr)
        return temp->data;
    else exit(2);
}
#ifndef UNIQUE
OnewayList::~OnewayList(){for(;this->remove(0););}
#endif
int OnewayList::find(int findme) const{
    if (!head)return -1;
    Node* curp=head
#ifdef UNIQUE
                     .get()
#endif
        ;int pos=0;
    while (curp->data!=findme){curp=curp->next
#ifdef UNIQUE
               .get()
#endif
            ;if (curp)pos++;else return -1;}return pos;}
